/*
Copyright 2010-2011 Zhengmao HU (James)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package net.sf.jabb.util.stat;

import java.util.concurrent.atomic.AtomicLong;

/**
 * ṩͳϢ
 * ֵСֵƽֵܼơ
 * Ƕ̰߳ȫġ
 * @author Zhengmao HU (James)
 *
 */
public class BasicNumberStatistics {
	protected AtomicMinLong min;
	protected AtomicMaxLong max;
	protected AtomicLong sum;
	protected AtomicLong count;
	
	public BasicNumberStatistics(){
		min = new AtomicMinLong();
		max = new AtomicMaxLong();
		sum = new AtomicLong();
		count = new AtomicLong();
	}
	
	/**
	 * һֵṩͳ
	 * @param value		ҪṩͳƵֵ
	 */
	public void put(long value){
		min.min(value);
		max.max(value);
		sum.addAndGet(value);
		count.incrementAndGet();
	}
	
	/**
	 * ǷͳƵݴڣû쳣
	 */
	protected void ensureDataExists(){
		if (getCount() <= 0){
			throw new IllegalStateException("No data input for statistics.");
		}
	}
	
	/**
	 * ȡƽֵǰûṩκֵͳã׳쳣
	 * @return	ƽֵ
	 */
	public double getAvg(){
		ensureDataExists();
		return (double)getSum()/getCount();
	}
	
	/**
	 * ȡСֵǰûṩκֵͳã׳쳣
	 * @return	Сֵ
	 */
	public long getMin() {
		ensureDataExists();
		return min.get();
	}
	
	/**
	 * ȡֵǰûṩκֵͳã׳쳣
	 * @return	ֵ
	 */
	public long getMax() {
		ensureDataExists();
		return max.get();
	}
	
	/**
	 * ȡüֵǰûṩκֵͳã򷵻0
	 * @return	ۼֵ
	 */
	public long getSum() {
		return sum.get();
	}
	
	/**
	 * ȡѾṩͳƵֵĸǰûṩκֵͳã򷵻0
	 * @return	
	 */
	public long getCount() {
		return count.get();
	}
	
	/**
	 * Reset to initial status.<br>
	 * ظʼ״̬
	 */
	public void reset(){
		min.reset();
		max.reset();
		sum.set(0);
		count.set(0);
	}

}
